#include <oxstd.h> // include the Ox standard library header
#include <oxdraw.h>
#include "testextern.ox"

class Test                        // Line is the class name
{
    decl x, y;                          // two data members
    Test(a);                        // constructor
    getX();
    getY();
    setX(a);
    setY(const b);
    sum();
    externalWrapper();
    getMatrix();
    getMatrixScalar();	
    getMatrixEmpty();
    getString(a);
    getStringArray(a);
    setGetMatrix(a);
    setGetStringArray(a);	
    getStringArrayBack(a);
};                     

Test::Test(a)
{	
    x = y = a;               // set cursor at the origin
    print("number x: ",x, "\n");
AA = 2;
	
}


Test::getX()
{

  return x;	
}
Test::getY()
{
 return y;	
}
Test::setX(a)
{
  x = a;
  print("new number x: ",x, "\n");		
}
Test::setY(const b)
{
  y = b;	
}

Test::sum()
{
  y = y + x;	
}

Test::getMatrix()
{
  return unit(5);
}
Test::getMatrixScalar()
{
  return unit(1);
}
Test::getMatrixEmpty()
{
  return unit(0);
}


Test::externalWrapper()
{
  return externalProc();
}

Test::getString(a)
{

  return a + "testString";	
}

Test::getStringArray(a)
{
print("print sarray: ",a, "\n");	
decl x = {{"testString0" , "testString1"}, {"testString2" , 2}, {2.23, "testString4"}};
print("print sarray: ",x, "\n");	
  return x;	
}

Test::getStringArrayBack(a)
{
  return {a, 23};	
}

Test::setGetMatrix(a)
{
  print("a*2:", a*2, "\n");
return a*2;
 	
}

Test::setGetStringArray(a)
{
  return a;		
}